require 'topdmc/resources/artist'
require 'topdmc/resources/search'
require 'topdmc/resources/album'
require 'topdmc/resources/track'
require "topdmc/resources/version"

module TopDMC
  class Client
    attr_accessor :client_id, :client_secure , :url
    attr_writer :user_agent

    def initialize(options={})
      @client_id = options[:client_id]
      @client_secure = options[:client_secure]
      @url = options[:url]||'http://openapi.topdmc.cn'

      yield(self) if block_given?
    end

    def user_agent
      @user_agent ||= "TopDMC/#{TopDMC::Resources::VERSION}"
    end

    def artist
      TopDMC::Resources::Artist.new(self)
    end

    def album
      TopDMC::Resources::Album.new(self)
    end

    def track
      TopDMC::Resources::Track.new(self)
    end

    def search
      TopDMC::Resources::Search.new(self)
    end

  end
end
