require 'topdmc/resources/base'

module TopDMC
  module Resources
      class Track < Base
        def initialize(client)
          super(client)
        end

        def find(id)
          perform_request('GET', "/v1/tracks/#{id}")
        end

        def find_all_by_ids(ids)
          perform_request('GET', "/v1/tracks", {ids: ids.join(',')})
        end

        def get_mapping(id)
          perform_request('POST', "/v1/tracks/#{id}/mapping")
        end

        def create_mapping(id, params)
          perform_request('GET', "/v1/tracks/#{id}/mapping", params)
        end

        def delete_mapping(id)
          perform_request('DELETE', "/v1/tracks/#{id}/mapping")
        end

        def update_offline_play_count(id, params)
          perform_request('PUT', "/v1/tracks/#{id}", params)
        end

        def authorize_url(track_id,params={})
          base_params ={
              timestamp: Time.now.to_i,
              nonce: nonce,
              client_id: @client.client_id
          }

          params.merge! base_params
          params[:sign] = sign('GET',"/v1/tracks/#{track_id}/authorize",params,@client.client_secure)

          query = params.map { |key, value|
            [key, URI.encode_www_form_component(value.to_s)]
          }.sort.map { |item| item.join('=') }.join('&')

          "#{@client.url}/v1/tracks/#{track_id}/authorize?#{query}"
        end
    end
  end
end
